/*
  REVIVE_PLAYER SCRIPT - AI disabled

  Adds revive and drag actions to playable units as well as reward and team kill functions

  MARCH 2008 - norrin (norrins_nook@iprimus.com.au) 
  Revised by Xeno (www.germany-fun.de)

  Version:  1.46 
********************************************************************************************************
Start Revive_player.sqf
*/
private ["_Base_1","_bonus","_c","_can_be_revived","_can_be_revived_2","_can_revive","_can_revive_2","_hint","_killer","_max_respawns","_mrker_pos","_mrkr_ex","_name","_no_left","_no_respawns","_no_revives","_no_team_kills","_player_side","_respawns_left","_revives","_revives_remain","_revives_required","_revives_till_bonus","_reward_function","_team_kill_function","_unconscious_markers","_units","_r_marker_side"];
//Do not touch these variables
_units 			= NORRN_player_units;
_name 			= player;
_player_side 		= playerSide;
_c 				= 0;
_cc 				= 0;

_reward_function 		= NORRN_revive_array select 1;
_team_kill_function 	= NORRN_revive_array select 2;
_unconscious_markers	= NORRN_revive_array select 6;

_Base_1 			= NORRN_revive_array select 13;

_can_revive			= NORRN_revive_array select 19;
_can_revive_2 		= NORRN_revive_array select 20;
_can_be_revived 		= NORRN_revive_array select 21;
_can_be_revived_2 	= NORRN_revive_array select 22;

_max_respawns 		= NORRN_revive_array select 26;
_revives_required 	= NORRN_revive_array select 29;
_no_team_kills 		= NORRN_revive_array select 30;
_unc_drag 			= NORRN_revive_array select 47;

_mobile_spawn 		= NORRN_revive_array select 51;
_mobile_base_start 	= NORRN_revive_array select 52;

NORRN_body_no 		= 0;
NORRN_X_respawn 		= false;
NORRN_X_concious 		= false;
NORRN_X_dead 		= false;
NORRN_remove_drag 	= false;

call compile format ["say_%1 = false", _name];
_bonus = 0;
_x_NORRN_units = [];
commentsBrian = ["Brian_Im_hit","Brian_Im_bleeding","Brian_Medic","Brian_Bastards","Brian_Shit_Man_down","Brian_Oh_no","Brian_Fuck","Brian_Fuck_it","Brian_Shit","Brian_Need_help","Brian_A_little_help_here"];

//Probably best not to play with the following code unless you know what you are doing
sleep 0.5 + random 4;

//Set and broadcast dynamic variables
call compile format ["%1_revives = 0", _name];
call compile format ["revive_%1 = 0; publicVariable ""revive_%1""", _name];
call compile format ["%1_killer = 0; publicVariable ""%1_killer""", _name];
call compile format ["%1_a = false; publicVariable ""%1_a""", _name];
{call compile format ["if (isplayer %1) then {_x_NORRN_units = _x_NORRN_units + [%1]}", _x]} forEach _units;
_r_marker_side = "";
switch (playerSide) do {
	case west: {_r_marker_side = "respawn_west";};
	case east: {_r_marker_side = "respawn_east";};
	case resistance: {_r_marker_side = "respawn_guerrila";};
	case civilian: {_r_marker_side = "respawn_civilian";};
};
NORRN_respawn_mrkr = markerPos _r_marker_side;

sleep 0.5;

//Set-up marker for mobile spawn
if (_mobile_spawn == 1) then
{
	if (NORRN_camo_net) then 
	{ 
		_mrkr_mbl = "mobile";
		createMarkerLocal [_mrkr_mbl, getPos r_mobile_spawn_vcl];
		_mrkr_mbl setMarkerColorLocal "ColorBlue";
		_mrkr_mbl setMarkerTypeLocal "Flag1";
		_mrkr_mbl setMarkerTextLocal _Base_1;
		_mrkr_mbl setMarkerSizeLocal [0.4, 0.4];
	}else{
		_mrkr_mbl = "mobile";
		createMarkerLocal [_mrkr_mbl, getMarkerPos _mobile_base_start];
		_mrkr_mbl setMarkerColorLocal "ColorBlue";
		_mrkr_mbl setMarkerTypeLocal "Flag1";
		_mrkr_mbl setMarkerTextLocal _mobile_base_start;
		_mrkr_mbl setMarkerSizeLocal [0.4, 0.4];
	};
};
	
//Get and set existing unconcious markers
{call compile format ["if (isplayer %1 && %1_a && _unconscious_markers == 1) then 
{
	_mrker_pos = [NORRN_pos_x_%1, NORRN_pos_y_%1, 0];
	_mrkr_ex = ""%1 is down"";
	createMarkerLocal [_mrkr_ex, _mrker_pos];
	_mrkr_ex setMarkerColorLocal ""ColorBlue"";
	_mrkr_ex setMarkerTypeLocal ""Flag1"";
	_mrkr_ex setMarkerTextLocal ""%2 is down"";
	_mrkr_ex setMarkerSizeLocal [0.4, 0.4];}",_x, name _x];}forEach _x_NORRN_units;


//Prompt joining player the no revives remaining
if (_max_respawns != 1000) then {
	_revives = call compile format ["%1_revives", _name];
	_revives_remain = _max_respawns - _revives;
	_no_revives = format ["Lives remaining: %1 out of %2", _revives_remain, _max_respawns];
	hint _no_revives;
};

//initialise team kill function
if (_team_kill_function == 1 && _max_respawns != 1000) then {
	_name addeventhandler ["killed", {_this execVM "revive_sqf\team_killer.sqf"}];
};

player execVM "revive_sqf\r_killedhandler.sqf";

if (player distance NORRN_respawn_mrkr < 50 || player distance getMarkerPos "Boot_Hill" < 50) then {player setPos getMarkerPos _Base_1}; 

//Body of the script
while {true} do 
{	
	if (NORRN_X_dead) exitWith {};
	
	sleep 0.1;
	
	//While player alive
	if (alive player && !NORRN_X_respawn && !NORRN_X_concious && !NORRN_X_dead) then {
		_name = player;
						
		//add revive action for when player gets in range of unconcious unit
		if (count (nearestObjects [_name, [_can_be_revived, _can_be_revived_2], 3]) > 1) then {
			if (_name isKindOf _can_revive && _c == 0 && animationState (nearestObjects [_name, [_can_be_revived, _can_be_revived_2], 3] select 1) == "AmovPpneMstpSnonWnonDnon_healed" ||
			    _name isKindOf _can_revive_2 && _c == 0 && animationState (nearestObjects [_name, [_can_be_revived, _can_be_revived_2], 3] select 1) == "AmovPpneMstpSnonWnonDnon_healed") then {
				call compile format ["%1_myaction = %1 addAction ['Revive', 'revive_sqf\heal.sqf','', 0, false, true];", player]; 
				_c = _c + 1;		
			};					
			if (_c == 1 && animationState (nearestObjects [_name, [_can_be_revived, _can_be_revived_2], 3] select 1) != "AmovPpneMstpSnonWnonDnon_healed") then {
				call compile format ["%1 removeAction %1_myaction", _name];
				_c = 0;
				sleep 0.5; 		
			};
		};
		if (count (nearestObjects [_name, [_can_be_revived, _can_be_revived_2], 3]) == 1 && _c == 1) then {
			call compile format ["%1 removeAction %1_myaction", _name];
			_c = 0;		
		};
		
		//add drag action for when player gets in range of unconcious unit
		if (_unc_drag == 1) then
		{
			if (NORRN_remove_drag) then
			{	
				_c = 0;
				_cc = 0;
				NORRN_remove_drag = false;
			};
			if (count (nearestObjects [_name, [_can_be_revived, _can_be_revived_2], 2]) > 1) then 
			{
				if (_cc == 0 && animationState (nearestObjects [_name, [_can_be_revived, _can_be_revived_2], 2] select 1) == "AmovPpneMstpSnonWnonDnon_healed" ||
			    	_cc == 0 && animationState (nearestObjects [_name, [_can_be_revived, _can_be_revived_2], 2] select 1) == "AmovPpneMstpSnonWnonDnon_healed") then 
				{
					call compile format ["%1_myaction_drag = %1 addAction ['Drag body', 'revive_sqf\drag.sqf','', 0, false, true];", player]; 
					_cc = _cc + 1;		
				};					
				if (_cc == 1 && animationState (nearestObjects [_name, [_can_be_revived, _can_be_revived_2], 2] select 1) != "AmovPpneMstpSnonWnonDnon_healed") then 
				{
					call compile format ["%1 removeAction %1_myaction_drag", _name];
					_cc = 0;
					sleep 0.5; 		
				};
			};
			if (count (nearestObjects [_name, [_can_be_revived, _can_be_revived_2], 2]) == 1 && _cc == 1) then 
			{
				call compile format ["%1 removeAction %1_myaction_drag", _name];
				_cc = 0;		
			};	
		};
		call compile format ["if (%1_killer == _no_team_kills && _team_kill_function == 1 && _max_respawns != 1000) then {
			If (NORRNCustomExec2 != '') then {call compile NORRNCustomExec2};
			_no_respawns = %1_revives + 1;
			_respawns_left = _max_respawns - _no_respawns;
			_no_left = ""You have lost a life for excessive team killing."";
			if (local _name) then {hint _no_left};
			%1_revives = _no_respawns; 
			%1_killer = 0;
			publicVariable ""%1_killer"";
		};", _name]; 
		
		//revive/reward function
		call compile format ["if (revive_%1 >= _revives_required && _reward_function == 1 && _max_respawns != 1000) then {
			_no_respawns = %1_revives - 1;
			_respawns_left = _max_respawns - _no_respawns;
			_no_left = ""You have received a bonus life for teamplay."";
			hint _no_left;
			%1_revives = _no_respawns; 
			revive_%1 = 0;
			_bonus = 0;
			publicVariable ""revive_%1"";
		};", _name];

		//prompt the number of revives required for next bonus
		if (_reward_function == 1 && _max_respawns != 1000 && _bonus != call compile format ["revive_%1", _name]) then {
			_bonus = call compile format ["revive_%1", _name];
			_revives_till_bonus = _revives_required - _bonus;
			_hint = format ["Revives required for next bonus: %1", _revives_till_bonus];
			hint _hint;
		};
		
		sleep 0.5;
	} else {
		sleep 0.5;
	};
};

if (true) exitWith {};
