/*
  r_KILLEDHANDLER - AI disabled

  Creates playable units that fall unconcious when killed which can then be revived

   MARCH 2008
  Xeno (www.germany-fun.de)
  norrin (norrins_nook@iprimus.com.au) 

  Version:  1.46 (Revivable Players - AI disabled) for ArmA version 1.08
*******************************************************************************************************  
  By Xeno based on the scripts of norrin further updated by norrin with new features
                    
*******************************************************************************************************
Start r_killedhandler.sqf
*/

private ["_Base_1","_base_1_distance","_Base_2","_base_2_distance","_Base_3","_base_3_distance","_Base_4","_base_4_distance","_base_distance","_bee","_call_out_function","_can_be_revived","_can_be_revived_2","_can_revive","_can_revive_2","_d","_dead_body","_dead_body_position","_dialog_1","_e","_group","_kegetys_spectator","_leader","_magazines","_max_respawns","_mrkr","_name","_name_player","_near_Objects","_no_left","_no_respawn_points","_no_respawns","_no_team_kills","_NORRN_dir","_NORRN_pos","_NORRN_random","_player","_player_killed_again","_player_side","_respawn_at_base","_respawn_base","_respawn_position","_respawns_left","_revive_time","_revive_time_limit","_revive_timer","_revive_timer_type","_reviver","_revives_required","_reward_function","_team_kill_function","_unconscious_markers","_unit_type","_water","_water_dialog","_weapons","_unconscious_body","_init_string","_r_marker_side"];
if (!(local player)) exitWith {};


_reward_function 			= NORRN_revive_array select 1;
_team_kill_function 		= NORRN_revive_array select 2;
_unconscious_markers 		= NORRN_revive_array select 6;
_call_out_function 		= NORRN_revive_array select 8;
_revive_timer 			= NORRN_revive_array select 9;
_kegetys_spectator 		= NORRN_revive_array select 11;

_no_respawn_points  		= NORRN_revive_array select 12;
_Base_1 				= NORRN_revive_array select 13;
_Base_2 				= NORRN_revive_array select 14;
_Base_3 				= NORRN_revive_array select 15;
_Base_4 				= NORRN_revive_array select 16;

_can_revive 			= NORRN_revive_array select 19;
_can_revive_2 			= NORRN_revive_array select 20;
_can_be_revived 			= NORRN_revive_array select 21;
_can_be_revived_2 		= NORRN_revive_array select 22;

_max_respawns 			= NORRN_revive_array select 26;
_revives_required 		= NORRN_revive_array select 29;
_no_team_kills 			= NORRN_revive_array select 30;
_revive_timer_type 		= NORRN_revive_array select 31;
_respawn_position 		= NORRN_revive_array select 32;
_revive_time_limit 		= NORRN_revive_array select 33;
_water_dialog 			= NORRN_revive_array select 38;
NORRN_revive_damage 		= NORRN_revive_array select 39;
_visible_timer 			= NORRN_revive_array select 42;
_HULK_rProne 			= NORRN_revive_array select 43;
_rejoin_punish 			= NORRN_revive_array select 45;
_rejoin_punish_revives 		= NORRN_revive_array select 46;
_unc_drag 				= NORRN_revive_array select 47;
_drop_weapons	 		= NORRN_revive_array select 48; 			
_cadaver	 			= NORRN_revive_array select 49;

_name_player = name player;
_player_side = playerSide;
_unit_type = typeOf player;
_group = group player;
_leader = leader _group;

_unconscious_body = objNull;
_dead_again = false;

//New code for MAPFACT rejoin
if (MAP_r_rejoin) then {_max_respawns = MAP_r_no_lives};

while {true} do 
{
	scopeName "r_killedhandler";
	waitUntil {!alive player || _dead_again};  
	_player = player;
	_dead_body = _player;
	_dead_body_position = getPos _dead_body;

	_water = false;
	_weapons = weapons _dead_body;
	_magazines = magazines _dead_body;
	_player_killed_again = false;
	_respawn_at_base = false;
	
	NORRN_r_time_expire = false;
	_dead_again = false;
	
	_NORRN_random = 0;	
	_d = 0;
		
	enableRadio false;
	
	////sickboy's code modified by _xeno 
	if (!isNil "T_Server" && !isNil "T_Client") then 
	{
		if (!T_Server && T_Client) then {disableUserInput true;};
	} else {
		disableUserInput true;
	};
	
	_NORRN_pos = getPos _dead_body; 
	_NORRN_dir = getDir _dead_body;
	NORRN_Offset = _dead_body distance _NORRN_pos;
	
	NORRN_unc_array = [];
	call compile format ["NORRN_pos_x_%1 = _NORRN_pos select 0; 
				    NORRN_pos_y_%1 = _NORRN_pos select 1;
				    NORRN_dir_%1 = _NORRN_dir;
				    NORRN_Offset_%1 = NORRN_Offset;
				    publicVariable 'NORRN_pos_x_%1';
				    publicVariable 'NORRN_pos_y_%1'; 
				    publicVariable 'NORRN_dir_%1';
				    publicVariable 'NORRN_Offset_%1';", _dead_body];
		
	if (!isNull _unconscious_body) then {
		deleteVehicle _unconscious_body;
		_unconscious_body = objNull;
	};
	titlecut [" ","BLACK OUT",10];
	
	NORRN_X_respawn = true;
	NORRN_X_concious = false;
	
	call compile format ["if (_max_respawns  <= %1_revives) then {NORRN_X_dead = true};", _player];
	
	sleep 0.1;			
	
	if (surfaceIsWater getPos player && !NORRN_X_dead) then 
	{
		_water = false;
		//anti-water code
		if (surfaceIsWater getPos player) then 
		{	
			waitUntil{alive player};
			player setPos [_dead_body_position select 0,_dead_body_position select 1,0];
			player setCaptive true;
			if (_water_dialog == 1) then 
			{
				titleText ["Choose wash ashore or press escape to close dialog and start at current position","PLAIN", 0.4]; 
				_dialog_1 = createDialog "respawn_button_1c";
			};
			titlecut [" ","BLACK IN", 0.4];	
		}; 
		while {surfaceIsWater getPos player} do 
		{		
			disableUserInput false;
			if(!alive player) then {_dead_body = player; waitUntil{alive player};player setPos [_dead_body_position select 0,_dead_body_position select 1,0];player setCaptive true;};	
			if (primaryWeapon player != "") then {player action ["WEAPONONBACK", player]};
			player setdammage 0;
			deleteVehicle _dead_body;
			if (vehicle player != player && player == driver (vehicle player)) then {player action ["GETOUT", vehicle player]};
			if (vehicle player != player && player == gunner vehicle player) then {player action ["GETOUT", vehicle player]};
			_water = true;
			sleep 1;
		};
		sleep 0.1;
		if (!surfaceIsWater getPos player && _water) then {
			if (vehicle player != player) then {player action ["GETOUT", vehicle player]};
			player setCaptive false;
			titlecut [" ","BLACK OUT",10];
			_NORRN_pos = getPos player;
			_NORRN_dir = getDir player;
			NORRN_Offset = player distance _NORRN_pos;
			player switchMove "AmovPpneMstpSnonWnonDnon_healed";
			sleep 1;	
			if (!isNull _unconscious_body) then 
			{
				_unconscious_body setPos _NORRN_pos;
				_unconscious_body setDir _NORRN_dir;
			};
			call compile format ["NORRN_pos_x_%1 = _NORRN_pos select 0; NORRN_pos_y_%1 = _NORRN_pos select 1, publicVariable 'NORRN_pos_x_%1';publicVariable 'NORRN_pos_y_%1'", player];	
			player setPos NORRN_respawn_mrkr;
			sleep 0.1;
			_water = false;
			disableUserInput true;
		};
	};
	sleep 0.1;
	
	call compile format ["%1_a = true; publicVariable ""%1_a""", player];
	
	//If player is down start camera
	if (!NORRN_X_dead) then 
	{
		_bee = "butterfly" createVehicle  _NORRN_pos;
		[_bee, _NORRN_pos, _name_player] execVM "revive_sqf\cam_follow.sqf";
		sleep 0.123;
	};
	
	//move body
	NORRN_X_respawn = true;
	waitUntil {alive player};
	_name = player;
	_name playMove "AmovPpneMstpSnonWnonDnon_healed";
	sleep 0.5;
	
	call compile format ["_unit_type createUnit [[_NORRN_pos select 0,_NORRN_pos select 1, NORRN_Offset], group server, 'this setcaptive true;
											    removeAllWeapons this;
											    this switchMove ''AmovPpneMstpSnonWnonDnon_healed'';
											    this disableAI ''ANIM'';
											    this setdamage NORRN_revive_damage;
											    this setDir NORRN_dir_%1; 
											    this setPos [NORRN_pos_x_%1,NORRN_pos_y_%1, NORRN_Offset_%1];
												       
											    {this addMagazine _x;} forEach magazines %1;
											    {this addWeapon _x;} forEach weapons %1;
											    this addeventhandler [''hit'', {if (!isNull (_this select 0)) then {(_this select 0) setdamage 0;};}];
											    this addeventhandler [''dammaged'', {if (!isNull (_this select 0)) then {(_this select 0) setdamage 0;};}]']", _name];   

	
	if (!NORRN_X_dead) then {deleteVehicle _dead_body;};
	sleep 2;
	
	_unc_body = false;
	_bodies = nearestObjects [[_NORRN_pos select 0,_NORRN_pos select 1, NORRN_Offset], [_can_be_revived, _can_be_revived_2], 10];
	_count_bodies = count _bodies;
	if (_count_bodies > 0) then {if (animationstate (_bodies select 0) == "AmovPpneMstpSnonWnonDnon_healed" && !_unc_body) then {_unconscious_body = _bodies select 0; _unc_body = true}};
	if (_count_bodies > 1) then {if (animationstate (_bodies select 1) == "AmovPpneMstpSnonWnonDnon_healed" && !_unc_body) then {_unconscious_body = _bodies select 1; _unc_body = true}};
	if (_count_bodies > 2) then {if (animationstate (_bodies select 2) == "AmovPpneMstpSnonWnonDnon_healed" && !_unc_body) then {_unconscious_body = _bodies select 2; _unc_body = true}};
	if (_count_bodies > 3) then {if (animationstate (_bodies select 3) == "AmovPpneMstpSnonWnonDnon_healed" && !_unc_body) then {_unconscious_body = _bodies select 3}};
	unconscious_body = _unconscious_body;
	
	//create marker at scene of unconcious player
	if (_unconscious_markers == 1 && !NORRN_X_dead  && !_respawn_at_base) then
	{
		_mrkr = format["%1 is down", player]; 
		createMarker [_mrkr, _NORRN_pos];
		_mrkr setMarkerColor "ColorBlue";
		_mrkr setMarkerType "Flag1";
		_mrkr setMarkerText format["%1 is down", _name_player]; 
		_mrkr setMarkerSize [0.4, 0.4];
	};
	
	sleep 0.05;
	disableUserInput false;
	NORRN_X_concious = true;	
	
	//player unconcious
	if (_revive_timer == 0 && !NORRN_X_dead) then 
	{	
		while {alive player && NORRN_X_respawn && NORRN_X_concious && !_respawn_at_base} do 
		{
			call compile format ["if (%1_respawn_at_base) then {_respawn_at_base = true}", _name];
			//call-out while unconcious
			if (_call_out_function == 1 && _d == 0) then 
			{
				if (!isNull _unconscious_body) then 
				{
					_unconscious_body setVehicleInit "this say (commentsBrian select floor(random 11))";
					processInitCommands;
				};
				_NORRN_random = 75 + ceil(random 25);
			};
			_d = _d + 1;
			if (_d == _NORRN_random) then {_d = 0}; 
					
			sleep 0.2;
				
			//reviver is within the revive radius and is reviving - unit revived
			_near_Objects = [];
			if (!isNull _unconscious_body) then 
			{
				_near_Objects = nearestObjects [_unconscious_body, [_can_be_revived, _can_be_revived_2], 3];
			};
			if (alive player && count _near_Objects > 1) then 
			{
				call compile format ["if (%1_respawn_at_base) then {_respawn_at_base = true}", _name];
		
				_e = 0;
				
				{if(animationState _x == "AinvPknlMstpSlayWrflDnon_medic")then {_e = _e + 1}}forEach _near_Objects;
				if (_e >= 1) then 
				{
					sleep 0.1;
									
						_reviver = _near_Objects select 1;
						if(animationState _reviver != "AinvPknlMstpSlayWrflDnon_medic") then 
						{
							if (count _near_Objects > 2) then 
							{
								_reviver = _near_Objects select 2;
								if(animationState _reviver != "AinvPknlMstpSlayWrflDnon_medic") then 
								{
									if (count _near_Objects > 3) then 
									{
										_reviver = _near_Objects select 3;
									};
								};
							};
						};
		
					sleep 1;
					
					if (_reward_function == 1 && _max_respawns != 1000) then 
					{
						call compile format ["revive_%1 = revive_%1 + 1; publicVariable ""revive_%1""", _reviver];
					};
					
					//Create var for reviver's name
					_revive_message  = format ["%1 has been revived by %2", name _name, name _reviver];
					call compile format ["reviver_%1 = '%2';publicVariable 'reviver_%1';", _name, _revive_message];			 				
				
					//Set current unit status unconcious
					call compile format ["%1_a = false; publicVariable ""%1_a""", _name];
		
					//if drag unit enabled get the current position of the unconscious body
					if (_unc_drag == 1) then
					{
						_unc_dir = getDir _unconscious_body;
						_NORRN_dir = _unc_dir;			
						_NORRN_pos = getPos _unconscious_body;
						NORRN_Offset = _unconscious_body distance _NORRN_pos;
					};
					sleep 0.1;

					_name = player;
					if (NORRN_respawn_mrkr distance _NORRN_pos > 1000) then {
						_name setCaptive true;
						_center_x = _NORRN_pos select 0;
						_center_y = _NORRN_pos select 1;
						_radius = 1000;
						_angle = 0;
						_found_it = false;
						_set_pos = [(_NORRN_pos select 0) - 1000, _NORRN_pos select 1];
						while {_angle < 350 && !_found_it} do {
							_x1 = _center_x - (_radius * sin _angle);
							_y1 = _center_y - (_radius * cos _angle);
							if (!(surfaceiswater [_x1, _y1])) then {
								_set_pos = [_x1, _y1];
								_found_it = true;
							} else {
								_angle = _angle + 15;
								sleep 0.01;
							};
						};
						if (_angle == 360) then {_set_pos = NORRN_respawn_mrkr};
						_name setPos [_set_pos select 0, _set_pos select 1, 0];
						_name playMove "AmovPpneMstpSnonWnonDnon_healed";          
						sleep 4;
						_name setdamage NORRN_revive_damage;
						_name setDir _NORRN_dir;
						_name setPos [_NORRN_pos select 0,_NORRN_pos select 1, NORRN_Offset];
						_name setCaptive false;
					} else {
						//Return player to position where they were shot
						_name playMove "AmovPpneMstpSnonWnonDnon_healed";
						sleep 4;
						_name setdamage NORRN_revive_damage;
						_name setDir _NORRN_dir;
						_name setPos [ _NORRN_pos select 0, _NORRN_pos select 1, NORRN_Offset];
					};
					
					//User's code
					if (NORRNCustomExec1 != "") then {call compile NORRNCustomExec1};
					
					//increment respawn counter
					if (local _name && _max_respawns != 1000) then {
						_no_respawns = call compile format ["%1_revives", _name] + 1;
						_respawns_left = _max_respawns - _no_respawns;
						_no_left = format ["Lives remaining: %1", _respawns_left];
						hint _no_left;
						call compile format ["%1_revives = _no_respawns", _name];
					};
					enableRadio true;
					
					//prompt reviver's name
					call compile format ["player setVehicleInit 'server globalChat reviver_%1'", _name];
					processInitCommands;
					call compile format ["titlecut ['\nYou have been revived by %1','PLAIN DOWN',0.4]", name _reviver];							
					
					if (!isNull _unconscious_body) then {
						_unconscious_body removeAllEventHandlers "dammaged";
						_unconscious_body removeAllEventHandlers "hit";
						sleep 0.1;
						deleteVehicle _unconscious_body;
						_unconscious_body = objNull;
					};
					
					// 'prone hack' by HulkingUnicorn
					if (_HULK_rProne == 1) then {[_name] execVM "revive_sqf\rPrn.sqf"}; 
					
					//Fix for leader 
					if (_leader != formleader _name) then {
						{_x doFollow _leader; _x doMove getPos _x} forEach units _group;
				
					};
												
					//reset variables
					if (alive player) then
					{
						NORRN_X_respawn = false;
						NORRN_X_concious = false;
					}else{
						_dead_again = true;
					};
					_name setCaptive false;
					_d = 0;
					sleep 0.1;
				
				};
			};
		};
	} else {
		if (alive player && NORRN_X_respawn && NORRN_X_concious && !NORRN_X_dead) then 
		{
			_revive_time = time + _revive_time_limit;
			sleep 0.05;
			
			//revive timer increment 
			_timer = time + 1;
			_timer_count = _revive_time_limit;
			
			while {alive player && NORRN_X_respawn && NORRN_X_concious && !_respawn_at_base && time < _revive_time} do 
			{
				call compile format ["if (%1_respawn_at_base) then {_respawn_at_base = true}", _name];
				//call-out while unconcious
				if (_call_out_function == 1 && _d == 0) then {
					if (!isNull _unconscious_body) then {
						_unconscious_body setVehicleInit "this say (commentsBrian select floor(random 11))"; 
						processInitCommands;
						_NORRN_random = 75 + ceil(random 25);
					};
				};
				_d = _d + 1;
				if (_d == _NORRN_random) then {_d = 0};
				
				//Revive count-down
				if(_visible_timer == 1) then
				{
					if (time > _timer) then
					{
						_timer = time + 1;
						_timer_count = _timer_count - 1;
						call compile format ["titleCut ['\n\nRevive Time Remaining: %1', 'PLAIN Down', 1]", _timer_count];
					};
				};
				
				sleep 0.2;
				
				_near_Objects = [];
				if (!isNull _unconscious_body) then 
				{
					_near_Objects = nearestObjects [_unconscious_body, [_can_be_revived, _can_be_revived_2], 3];
				};
				//reviver is within the revive radius and is reviving - unit revived
				if (alive player && count _near_Objects > 1) then 
				{
					call compile format ["if (%1_respawn_at_base) then {_respawn_at_base = true}", _name];			
		
					_e = 0;
					{if(animationState _x == "AinvPknlMstpSlayWrflDnon_medic")then {_e = _e + 1}}forEach _near_Objects;
					if (_e >= 1) then 
					{
						sleep 1;
															
						_reviver = _near_Objects select 1;
						if(animationState _reviver != "AinvPknlMstpSlayWrflDnon_medic") then {
							if (count _near_Objects > 2) then {
								_reviver = _near_Objects select 2;
								if(animationState _reviver != "AinvPknlMstpSlayWrflDnon_medic") then {
									if (count _near_Objects > 3) then {
										_reviver = _near_Objects select 3;
									};
								};
							};
						};
						sleep 0.1;
					
						if (local _name && _reward_function == 1 && _max_respawns != 1000) then 
						{
							call compile format ["revive_%1 = revive_%1 + 1; publicVariable ""revive_%1""", _reviver];
						}; 							
						
						//Create var for reviver's name
						_revive_message  = format ["%1 has been revived by %2", name _name, name _reviver];
						call compile format ["reviver_%1 = '%2';publicVariable 'reviver_%1';", _name, _revive_message];		
						
						//Set current unit status unconcious
						call compile format ["%1_a = false; publicVariable ""%1_a""", _name];
						
						//if drag unit enabled get the current position of the unconscious body
						if (_unc_drag == 1) then
						{	
							_unc_dir = getDir _unconscious_body;
							_NORRN_dir = _unc_dir;	
							_NORRN_pos = getPos _unconscious_body;
							NORRN_Offset = _unconscious_body distance _NORRN_pos;
						};
						sleep 0.1;
						
						_name = player;
						if (NORRN_respawn_mrkr distance _NORRN_pos > 1000) then 
						{
							_name setCaptive true;
							_center_x = _NORRN_pos select 0;
							_center_y = _NORRN_pos select 1;
							_radius = 1000;
							_angle = 0;
							_found_it = false;
							_set_pos = [(_NORRN_pos select 0) - 1000, _NORRN_pos select 1];
							while {_angle < 350 && !_found_it} do {
								_x1 = _center_x - (_radius * sin _angle);
								_y1 = _center_y - (_radius * cos _angle);
								if (!(surfaceiswater [_x1, _y1])) then {
									_set_pos = [_x1, _y1];
									_found_it = true;
								} else {
									_angle = _angle + 15;
									sleep 0.01;
								};
							};
							if (_angle == 360) then {_set_pos = NORRN_respawn_mrkr};
							_name setDir _NORRN_dir;
							_name setPos [_set_pos select 0, _set_pos select 1, 0];
							_name playMove "AmovPpneMstpSnonWnonDnon_healed";          
							sleep 4;
							_name setdamage NORRN_revive_damage;
							_name setDir _NORRN_dir;
							_name setPos [_NORRN_pos select 0,_NORRN_pos select 1, NORRN_Offset];
							_name setCaptive false;
						} else {
							//Return player to position where they were shot
							_name playMove "AmovPpneMstpSnonWnonDnon_healed";
							sleep 4;
							_name setdamage NORRN_revive_damage;
							_name setDir _NORRN_dir;
							_name setPos [_NORRN_pos select 0, _NORRN_pos select 1, NORRN_Offset];
						};
						
						//User's code
						if (NORRNCustomExec1 != "") then {call compile NORRNCustomExec1};
						
						//increment respawn counter
						if (local _name && _max_respawns != 1000) then {
							_no_respawns = call compile format ["%1_revives", _name] + 1;
							_respawns_left = _max_respawns - _no_respawns;
							_no_left = format ["Lives remaining: %1", _respawns_left];
							hint _no_left;
							call compile format ["%1_revives = _no_respawns", _name];
						};
						enableRadio true;
						
						//prompt reviver's name
						call compile format ["player setVehicleInit 'server globalChat reviver_%1'", _name];
						processInitCommands;
						call compile format ["titlecut ['\nYou have been revived by %1','PLAIN DOWN',0.4]", name _reviver];
						
						if (!isNull _unconscious_body) then {
							_unconscious_body removeAllEventHandlers "dammaged";
							_unconscious_body removeAllEventHandlers "hit";
							sleep 0.1;
							deleteVehicle _unconscious_body;
							_unconscious_body = objNull;
						};
						
						// 'prone hack' by HulkingUnicorn
						if (_HULK_rProne == 1) then {[_name] execVM "revive_sqf\rPrn.sqf"}; 
						
						//Fix for leader 
						if (_leader != formleader _name) then {
							{_x doFollow _leader; _x doMove getPos _x} forEach units _group;
				
						};
						
						if (_leader != formleader _name) then {
							{_x doFollow _leader; _x doMove getPos _x} forEach units _group;
				
						};
				
						//reset variables
						if (alive player) then
						{
							NORRN_X_respawn = false;
							NORRN_X_concious = false;
						}else{
							_dead_again = true;
						};
						_name setCaptive false;
						_d = 0;
						sleep 0.1;
					};
				};
			};
			
			if (alive player && NORRN_X_respawn && NORRN_X_concious && !_respawn_at_base && time >= _revive_time && !NORRN_X_dead) then 
			{
				if (_revive_timer_type == 0) then  
				{
					titleText ["Revive timer has been exceeded. You are dead", "BLACK", 10];
					NORRN_X_dead = true;
				};		
				if (_revive_timer_type == 1) then  
				{
					sleep 2;				
					//Unit respawns at mission start
					if (_respawn_position == 0) then 
					{	
						titleText ["Revive timer has been exceeded. Respawning at base", "PLAIN", 0.3];
						sleep 2;
						[1, _name] execVM "revive_sqf\respawn_at_base.sqf"; 
						_respawn_at_base = true
					}; 
					//Unit respawns at closest enemy free base
					if (_respawn_position == 1) then 
					{	
						titleText ["Revive timer has been exceeded. Respawning at marker", "PLAIN", 0.3];
						sleep 2;
						_base_1_distance =  _NORRN_pos distance getMarkerPos _Base_1;
						_base_2_distance =  _NORRN_pos distance getMarkerPos _Base_2;
						_base_3_distance =  _NORRN_pos distance getMarkerPos _Base_3;
						_base_4_distance =  _NORRN_pos distance getMarkerPos _Base_4;
						_base_distance = _base_1_distance;
						_respawn_base = 1;
						if (_base_distance > _base_2_distance && !no_base_2 && !no_base_2b) then {_base_distance = _base_2_distance; _respawn_base = 2;};
						if (_base_distance > _base_3_distance && !no_base_3 && !no_base_3b) then {_base_distance = _base_3_distance; _respawn_base = 3;};
						if (_base_distance > _base_4_distance && !no_base_4 && !no_base_4b) then {_base_distance = _base_4_distance; _respawn_base = 4;};
						sleep 0.01;
						[_respawn_base, _name] execVM "revive_sqf\respawn_at_base.sqf"; 
						_respawn_at_base = true;
					};
					//Unit respawns at chosen location
					if (_respawn_position == 2) then 
					{	
						NORRN_spawn_chosen = false;
						titleText ["Revive timer has been exceeded. Choose marker for respawn", "BLACK", 10];
						NORRN_r_time_expire = true;
						waitUntil {NORRN_spawn_chosen};
						titleText ["", "BLACK IN", 1];
						_respawn_at_base = true;
											
					};					
				};
				sleep 0.1;
			};
		};
	};
	
	if (!alive player && !NORRN_X_dead) then 
	{
		titlecut [" ","BLACK OUT",5];
		if (!isNull _unconscious_body) then 
		{
			_unconscious_body removeAllEventHandlers "dammaged";
			_unconscious_body removeAllEventHandlers "hit";
			_dead_body_position = position _unconscious_body;
			sleep 0.01;
			deleteVehicle _unconscious_body;
			_unconscious_body = objNull;
		};
		if (_unconscious_markers == 1) then {deleteMarker format["%1 is down", player]};
		sleep 0.01;
		_name = player;
		_name playMove "AmovPpneMstpSnonWnonDnon_healed";
		_name setPos [ _dead_body_position select 0, _dead_body_position select 1, NORRN_Offset];
		_name setDir _NORRN_dir;
		_player_killed_again = true;
	};
	
	if (!_player_killed_again && alive player && NORRN_X_respawn && NORRN_X_concious && _respawn_at_base && !NORRN_X_dead) then 
	{	
		sleep 0.2;
		_name setCaptive false;
		_name playmove "AmovPercMstpSrasWrflDnon";
		
					
		//Set current unit status unconcious
		call compile format ["%1_a = false; publicVariable ""%1_a""", _name];
		
		//if drag unit enabled get the current position of the unconscious body
		if (_unc_drag == 1) then
		{	
			_unc_dir = getDir _unconscious_body;
			_NORRN_dir = _unc_dir;	
			_NORRN_pos = getPos _unconscious_body;
			NORRN_Offset = _unconscious_body distance _NORRN_pos;
		};
		
		sleep 0.1;
		if (!isNull _unconscious_body) then 
		{
			_unconscious_body removeAllEventHandlers "dammaged";
			_unconscious_body removeAllEventHandlers "hit";  
			sleep 0.1;
			if (_drop_weapons == 1|| _cadaver == 1) then
			{	
				_upos = [_NORRN_pos select 0, _NORRN_pos select 1, NORRN_Offset];
				_unconscious_body setdamage 1;
				[_unconscious_body, _upos] execVM "revive_sqf\drop.sqf";
			};
			if (_drop_weapons == 0 && _cadaver == 0) then
			{
				deleteVehicle _unconscious_body;
				_unconscious_body = objNull;
			};
			sleep 0.1;
		};
		
		//Fix for leader 
		if (_leader != formleader _name) then 
		{
			{_x doFollow _leader; _x doMove getPos _x} forEach units _group;	
		};
		
		enableRadio true;
		
		//increment respawn counter		
		if (local _name && _max_respawns != 1000) then {
			_no_respawns = call compile format ["%1_revives", _name] + 1;
			_respawns_left = _max_respawns - _no_respawns;
			_no_left = format ["Lives remaining: %1", _respawns_left];
			hint _no_left;
			call compile format ["%1_revives = _no_respawns", _name];
		};			
	
		//reset variables
		call compile format ["%1_respawn_at_base = false; publicVariable ""%1_respawn_at_base""", _name];
		if (alive player) then
		{
			NORRN_X_respawn = false;
			NORRN_X_concious = false;
		}else{
			_dead_again = true;
		};
		_respawn_at_base = false;
		NORRN_r_time_expire = false;
		sleep 0.2;
	};
	
	sleep 0.1;
	
	if (_unconscious_markers == 1) then {deleteMarker format["%1 is down", player]};

	//if the unit is dead prompt player revive limit has been reached and select another slot
	if (NORRN_X_dead) exitWith {	
		[player] join grpNull;
		if (_unconscious_markers == 1) then {deleteMarker format["%1 is down", player]};
		if (_revive_timer == 1) then 
		{
			call compile format ["if (_max_respawns  > %1_revives) then {player switchMove 'AmovPpneMstpSnonWnonDnon'; sleep 4; player setPos _NORRN_pos;
					player setDir _NORRN_dir; player setDamage 1; deleteVehicle _unconscious_body; _unconscious_body = objNull; waitUntil {alive player}}", player];
		};
		if (!isNull _unconscious_body) then 
		{
			deleteVehicle _unconscious_body;
			_unconscious_body = objNull;
		};
	
		if (_kegetys_spectator == 1) then {titleText ["You are dead", "BLACK FADED", 2]; sleep 1; [_player, _player, "null"] execVM "spect\specta.sqf"};
				
		waitUntil{alive player};
		sleep 0.5;
	
		if (_revive_timer == 0 && _kegetys_spectator == 0 || _revive_timer == 1 && _kegetys_spectator == 0) then {titleText ["Player is dead. Please press escape, return to the unit selection menu and choose another playable unit", "BLACK FADED", 10]};
		[player] join grpNull;
		_players_list = NORRN_list;
		//added line for rejoin punish code
		{if ((name player) == _x && _rejoin_punish == 1 && _max_respawns != _rejoin_punish_revives) then {NORRN_list = NORRN_list - [_x]}} forEach _players_list;
		publicVariable "NORRN_list";
		breakout "r_killedhandler"; 
		sleep 5;		
	};
};

if (true) exitWith {};
